clc; close all
xBar = [1 10];% where the derivative is needed
testND = testFunctionsND;
f = @(x)testND.f10(x); % spring PE

[value,gradExact] = f(xBar);
KMax = 13;
h = zeros(1,KMax);
err = zeros(1,KMax);
FDMethod = -1; %Backward
for k = 1:KMax
    h(k) = 10^(-k);
    [gradFD] = finiteDifferenceGradient(f,xBar,h(k),FDMethod);
    err(k) = norm(gradExact-gradFD)/norm(gradExact);
end
loglog(h,err,':');hold on;

FDMethod = 1; %Forward
for k = 1:KMax
    h(k) = 10^(-k);
    [gradFD] = finiteDifferenceGradient(f,xBar,h(k),FDMethod);
    err(k) = norm(gradExact-gradFD)/norm(gradExact);
end

loglog(h,err,'--');hold on;

FDMethod = 0; %Central
for k = 1:KMax
    h(k) = 10^(-k);
    [gradFD] = finiteDifferenceGradient(f,xBar,h(k),FDMethod);
    err(k) = norm(gradExact-gradFD)/norm(gradExact);
end
loglog(h,err,'-r');hold on;

legend('Backward','Forward','Central');
xlabel('deltax'); ylabel('error');
grid on;

for k = 1:KMax
    h(k) = 10^(-k);
    [gradFD] = complexVariableGradient(f,xBar,h(k));
    err(k) = norm(gradExact-gradFD)/norm(gradExact);
    err(k) = max(err(k),eps); % we cannot plot zero error
end
loglog(h,err,'g-');hold on;
legend('Backward','Forward','Central','Complex');

