clc; clear all;close all
xBar = [1;10];
[f,gradExact] = springFunction(xBar);
KMax = 10;
h = zeros(1,KMax);
err = zeros(1,KMax);
FDMethod = -1; %Backward
for k = 1:KMax
    h(k) = 10^(-k);
    [gradFD] = finiteDifferenceGradient(@springFunction,xBar,[h(k);h(k)],FDMethod);
    err(k) = norm(gradExact-gradFD)/norm(gradExact);
end
loglog(h,err,':');hold on;


FDMethod = 1; %Forward
for k = 1:KMax
    h(k) = 10^(-k);
    [gradFD] = finiteDifferenceGradient(@springFunction,xBar,[h(k);h(k)],FDMethod);
    err(k) = norm(gradExact-gradFD)/norm(gradExact);
end
loglog(h,err,'--');hold on;

FDMethod = 0; %Central
for k = 1:KMax
    h(k) = 10^(-k);
    [gradFD] = finiteDifferenceGradient(@springFunction,xBar,[h(k);h(k)],FDMethod);
    err(k) = norm(gradExact-gradFD)/norm(gradExact);
end
loglog(h,err,'-r');hold on;

legend('Backward','Forward','Central');
xlabel('deltax'); ylabel('error');

for k = 1:KMax
    h(k) = 10^(-k);
    [gradFD] = complexVariableGradient(@springFunction,xBar,[h(k);h(k)]);
    err(k) = norm(gradExact-gradFD)/norm(gradExact);
    err(k) = max(err(k),eps); % we cannot plot zero error
end
loglog(h,err,'g-');hold on;
legend('Backward','Forward','Central','Complex');

