% LBracket
close all;
L = 0.1;%length in meters
H = 0.04;%height
rNominal = 0.01; % fillet radius
d = 0.005; % for force application
rMin = rNominal-0.0002;
rMax = rNominal+0.0002;
rValues = rMin:(rMax-rMin)/10:rMax;
delta = 0*rValues;
stress = 0*rValues;
pNormStress = 0*rValues;
for i = 1:numel(rValues)
    r = rValues(i);
    LBracket.vertices = [0 0;L 0; L H; L-d H; H+r H; H H+r; H L; 0 L; H+r H+r]';
    LBracket.edges = [1 2; 2 3; 3 4; 4 5; 5 6; 6 7; 7 8; 8 1]';
    LBracket.arcs = [5 9]';
    fem = TriElasticity(LBracket,4000);
    fem = fem.setYoungsModulus(2.1e11);
    fem = fem.setPoissonsRatio(0.28);
    fem = fem.fixEdge(7);
    fem = fem.applyYForceOnEdge(3,-100000);
    fem = fem.assemble();
    fem = fem.solve();
    delta(i) = fem.myMaxDelta;
    stress(i) = fem.myMaxStress;
    pNormStress(i) = fem.getPNormStress();
end
plot(rValues,delta,rValues,delta,'*'); xlabel('Fillet radius'); ylabel('Max displacement');
figure; plot(rValues,stress,rValues,stress,'*');xlabel('Fillet radius'); ylabel('Max stress'); grid on;

%figure; plot(rValues,pNormStress,rValues,pNormStress,'*');xlabel('Fillet radius'); ylabel('P-norm stress');

