%Parametric Study of stress versus volume
nSamples = 500;
nElements = 200;
L = 2.0;%length
H = 1;%height
h = 0.2; % length of force edge
aSamples = 0.05 + (0.4-0.05)*rand(nSamples,1);
bSamples = 0.05 + (0.4-0.05)*rand(nSamples,1);
S = zeros(nSamples,1);
V = zeros(nSamples,1);
for i = 1:nSamples
    [num2str(i) '/' num2str(nSamples)]
    a = aSamples(i); % corner cutouts
    b = bSamples(i); % left edge cutout
    cantilever.vertices = [b 0;0 -b; 0 -H/2;L-a -H/2;L -H/2+a; L -h/2; L h/2; L H/2-a; L-a H/2; 0 H/2; 0 b ]';
    cantilever.edges = [1 2; 2 3; 3 4; 4 5; 5 6; 6 7; 7 8; 8 9; 9 10; 10 11; 11 1];
    fem = TriElasticity(cantilever,nElements);
    fem = fem.setYoungsModulus(3.05e7);
    fem = fem.setPoissonsRatio(0.28);
    fem = fem.fixEdge([2,10]);
    fem = fem.applyYForceOnEdge(6,-1000);
    fem = fem.assemble();
    fem = fem.solve();
    S(i) = fem.myMaxStress;
    V(i) = fem.computeArea();
end
plot(V,S,'*');
xlabel('Volume (V)');
ylabel('Stress (J)');
