% shape optimization of cantilever beam 
format short
nElements = 200;
params0 = [0.1 0.35];% Design-1:a = 0.2, b = 0.4. Design-2: a= 0.1,b = 0.35
shapeOpt = cantilever2DMinComplianceSA(params0,nElements);

shapeOpt = shapeOpt.setParamsUpperBound([0.4,0.4]);
shapeOpt = shapeOpt.setParamsLowerBound([0.05,0.05]);
shapeOpt = shapeOpt.setTerminationTolerance(0.001);
shapeOpt = shapeOpt.setFiniteDifferenceStepSize(0.001);
results = shapeOpt.optimize();

disp('Initial Params: '); disp(results.initialParams);
disp('Final Params: '); disp(results.finalParams);

disp('Initial/Final Volume: '); disp([results.initialVolume results.finalVolume]);
disp('Initial/Final Compliance: '); disp([results.initialCompliance results.finalCompliance]);
disp('Initial/Final Stress: '); disp([results.initialStress results.finalStress]);

disp('#FEAs:'); disp(results.nFEAs);
