% shape optimization of cantilever beam
clear all; 
format short
params0 = [0.2 0.4];% initial shape parameters, a & b
shapeOpt = cantilever3DMinimizeDeflectionFD(params0);
shapeOpt = shapeOpt.setParamsUpperBound([0.4,0.4]);
shapeOpt = shapeOpt.setParamsLowerBound([0.05,0.05]);
shapeOpt = shapeOpt.setObjectiveTolerance(0.025);
shapeOpt = shapeOpt.setParamTolerance(0.025);
shapeOpt = shapeOpt.setFiniteDifferenceStepSize(0.01);
results = shapeOpt.minimizeMaxDisplacement();
disp('Initial Params: '); disp(results.initialParams);
disp('Final Params: '); disp(results.finalParams);

disp('Initial/Final Volume: '); disp([results.initialVolume results.finalVolume]);
disp('Initial/Final Displacement: '); disp([results.initialMaxDisplacement results.finalMaxDisplacement]);

disp('#FEAs:'); disp(results.nFEAs);
