function [xMin,fMin] = fminSampling(funToMinimize,a,b,nSamples)
% Find the global minimum of a function
% in an interval [a,b] through uniform sampling
% Usage: fminSampling(@(x)cos(x),0,2*pi,1000)
if (nargin < 4), nSamples = 100; end
if (nargin == 1), a = 0; b = 1; end
xSamples = linspace(a,b,nSamples);
fSamples = funToMinimize(xSamples); % evaluate function
[fMin, index] = min(fSamples);
xMin = xSamples(index);
