function [xMin,fMin,flag,output] = lineSearchNR(f,x0,d,opt)
% Exact line search of a N-dimensional function using 1D Newton Raphson
if (nargin == 3)
    opt = setDefaultOptimizationOptions();
end
x0 = x0(:); d = d(:); % make them column vector
d = d/norm(d); % ensure proper scaling
alpha0 = 0;
[alphaMin,fMin,flag,output] = fStationaryNR(@(alpha)f1D(f,x0,d,alpha),alpha0,opt);
xMin = x0 + alphaMin*d;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [fValue,df_dalpha,d2f_dalpha2] = f1D(f,x0,d,alpha)
[fValue, grad,hess] = feval(f,x0+alpha*d);% Evaluate f and derivatives at x0+alpha*d
% find the gradient of the 1D function along the direction
df_dalpha = grad(:)'*d(:);
d2f_dalpha2 =  d(:)'*hess*d(:);
